import "./style.css";
import { reactive as w, ref as W, watch as A, onActivated as B, nextTick as P, provide as F, onBeforeUnmount as U, resolveComponent as S, createBlock as j, openBlock as V, withCtx as _, createElementVNode as y, createVNode as E, withDirectives as I, vShow as O, createTextVNode as J } from "vue";
import { Button as z } from "@opentiny/vue";
import { PluginPanel as H, VueMonaco as G } from "@opentiny/tiny-engine-common";
import { useCanvas as m, useNotify as b, useModal as N, useHelp as R, useLayout as Y } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as q } from "@opentiny/tiny-engine-common/js/completion";
import { lint as K, initLinter as Q } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as X, string2Ast as x, formatString as Z, ast2String as $ } from "@opentiny/tiny-engine-common/js/ast";
import { constants as ee } from "@opentiny/tiny-engine-utils";
import { isFunction as te } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: L } = ee, r = w({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null,
  // 记录当前是否已经有弹窗，防止使用 ctrl + s 的时候重复弹窗
  hasErrorPopup: !1
}), c = W(null);
let h = null;
const v = () => {
  var e, n;
  const o = ((n = (e = m()).getSchema) == null ? void 0 : n.call(e)) || {};
  return o.methods = (o == null ? void 0 : o.methods) || {}, o.methods;
}, oe = () => m().pageState.pageSchema && Object.keys(v()) || [], C = () => {
  const e = Object.entries(v()).map(([n, t]) => X(n, t.value)).join(`
`);
  try {
    h = x(e);
  } catch (n) {
    b({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return e;
}, ne = (o) => {
  const e = /\r\n/g;
  if (r.isChanged = o.replace(e, `
`) !== r.script.replace(e, `
`), !c.value)
    return;
  const n = c.value.getEditor().getModel();
  K(n, r.linterWorker);
}, re = ({ name: o, content: e }) => {
  if (!o)
    return;
  const n = v(), t = {
    type: L.JSFunction,
    value: e
  };
  m().updateSchema({ methods: { ...n, [o]: t } });
}, k = async () => {
  const { message: o } = N();
  if (!r.isChanged || r.hasErrorPopup)
    return !1;
  if (r.hasError)
    return r.hasErrorPopup = !0, o({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存",
      exec: () => {
        r.hasErrorPopup = !1;
      }
    }), !1;
  const e = c.value.getEditor().getValue(), n = x(e), t = {};
  n.program.body.forEach((i, l) => {
    var p, g;
    const u = (p = i == null ? void 0 : i.id) == null ? void 0 : p.name;
    (g = n.program.body[l + 1]) != null && g.leadingComments && i.trailingComments === n.program.body[l + 1].leadingComments && delete i.trailingComments;
    const d = Z($(i).trim(), "javascript");
    u && (t[u] = {
      type: L.JSFunction,
      value: d
    });
  }), m().updateSchema({ methods: t }), m().setSaved(!1);
  const s = C();
  return r.script = "", await P(), r.script = s, r.isChanged = !1, b({
    type: "success",
    message: "保存成功！"
  }), !0;
}, se = (o) => (e) => {
  const { confirm: n } = N(), t = te(e) ? e : () => o("close");
  if (!r.isChanged) {
    t(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      t(k());
    },
    cancel() {
      t(!0);
    }
  });
}, ie = () => {
  if (!r.editorSelection || !c.value)
    return;
  const o = c.value.getEditor();
  o.setSelection(r.editorSelection), o.focus();
  const e = o.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  o.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: e
    },
    0
  );
}, ae = (o) => {
  var t;
  if (!o)
    return;
  const e = h == null ? void 0 : h.program.body.filter((s) => {
    var i;
    return o === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (e.length === 0)
    return;
  const n = (t = e[0]) == null ? void 0 : t.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && ie();
}, ce = ({ emit: o }) => (A(C, (e) => {
  r.script = e;
}), B(() => {
  P(() => {
    var e;
    r.script = C(), (e = c.value) == null || e.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: c,
  change: ne,
  saveMethods: k,
  close: se(o)
}), le = {
  saveMethod: re,
  highlightMethod: ae,
  getMethodNameList: oe,
  getMethods: v
}, ue = {
  components: {
    MonacoEditor: G,
    TinyButton: z,
    PluginPanel: H
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close"],
  setup(o, { emit: e }) {
    const n = R().getDocsUrl("script"), { state: t, monaco: s, change: i, close: l, saveMethods: u } = ce({ emit: e }), { PLUGIN_NAME: d } = Y(), p = w({
      emitEvent: e
    });
    F("panelState", p);
    const g = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      placeholder: `// ✅ 函数声明可以保存
       function topLevelFunction(){ 
      ​ ​ const message = 'hello tiny-engine.' 
      ​ ​ console.log(message) 
      } 
 
      // ❌ 顶层/常规 变量声明 
 const someVariable = 42 
      // ❌ 表达式 
 const result = someVariable + 10`,
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0,
      tabSize: 2,
      insertSpaces: !0,
      formatOnPaste: !0,
      formatOnType: !0,
      autoIndent: "full",
      newLineCharacter: `
`,
      convertTabsToSpaces: !0,
      trimAutoWhitespace: !0,
      wordWrap: "on",
      wordWrapColumn: 120,
      wordWrapMinChars: 10,
      wordWrapStrategy: "advanced"
    }, D = (f) => {
      var a;
      s.value && (t.completionProvider = q(s.value.getMonaco(), (a = s.value.getEditor()) == null ? void 0 : a.getModel()), t.linterWorker = Q(f, s.value.getMonaco(), t));
    };
    return U(() => {
      var f, a, M;
      (f = t.completionProvider) == null || f.forEach((T) => {
        T.dispose();
      }), (M = (a = t.linterWorker) == null ? void 0 : a.terminate) == null || M.call(a);
    }), {
      PLUGIN_NAME: d,
      state: t,
      monaco: s,
      options: g,
      close: l,
      change: i,
      saveMethods: u,
      editorDidMount: D,
      docsUrl: n
    };
  }
}, de = (o, e) => {
  const n = o.__vccOpts || o;
  for (const [t, s] of e)
    n[t] = s;
  return n;
}, pe = { class: "icon-wrap" }, me = { class: "red" }, ge = { class: "code-edit-content" };
function fe(o, e, n, t, s, i) {
  const l = S("tiny-button"), u = S("monaco-editor"), d = S("plugin-panel");
  return V(), j(d, {
    title: "页面 JS",
    "fixed-name": t.PLUGIN_NAME.Page,
    fixedPanels: n.fixedPanels,
    docsUrl: t.docsUrl,
    isShowDocsIcon: !0,
    onClose: e[0] || (e[0] = (p) => o.$emit("close")),
    class: "plugin-page-js-container plugin-script"
  }, {
    header: _(() => [
      y("span", pe, [
        I(y("i", me, null, 512), [
          [O, t.state.isChanged]
        ]),
        E(l, {
          type: "primary",
          onClick: t.saveMethods
        }, {
          default: _(() => e[1] || (e[1] = [
            J("保存")
          ])),
          _: 1
        }, 8, ["onClick"])
      ])
    ]),
    content: _(() => [
      y("div", ge, [
        E(u, {
          ref: "monaco",
          value: t.state.script,
          options: t.options,
          onChange: t.change,
          onEditorDidMount: t.editorDidMount,
          onShortcutSave: t.saveMethods
        }, null, 8, ["value", "options", "onChange", "onEditorDidMount", "onShortcutSave"])
      ])
    ]),
    _: 1
  }, 8, ["fixed-name", "fixedPanels", "docsUrl"]);
}
const he = /* @__PURE__ */ de(ue, [["render", fe], ["__scopeId", "data-v-c84ae87a"]]), ve = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "leftTop",
  width: 600,
  widthResizable: !0,
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, xe = {
  ...ve,
  apis: le,
  entry: he
};
export {
  xe as default
};
